
From: NeilBrown <neilb@cse.unsw.edu.au>

When a request crosses a boundary between devices, it needs to be split. 
But where we should calculate the amount of the request before the boundary
to find the split-point, we care currently calculating the amount that is
*after* the boundary !!!

Signed-off-by: Neil Brown <neilb@cse.unsw.edu.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/md/linear.c |    5 ++---
 1 files changed, 2 insertions(+), 3 deletions(-)

diff -puN drivers/md/linear.c~md-fix-splitting-of-md-linear-request-that-cross-a-device-boundary drivers/md/linear.c
--- 25/drivers/md/linear.c~md-fix-splitting-of-md-linear-request-that-cross-a-device-boundary	2005-05-09 22:30:09.000000000 -0700
+++ 25-akpm/drivers/md/linear.c	2005-05-09 22:30:09.000000000 -0700
@@ -269,9 +269,8 @@ static int linear_make_request (request_
 		 * split it.
 		 */
 		struct bio_pair *bp;
-		bp = bio_split(bio, bio_split_pool, 
-			       (bio->bi_sector + (bio->bi_size >> 9) -
-				(tmp_dev->offset + tmp_dev->size))<<1);
+		bp = bio_split(bio, bio_split_pool,
+			       ((tmp_dev->offset + tmp_dev->size)<<1) - bio->bi_sector);
 		if (linear_make_request(q, &bp->bio1))
 			generic_make_request(&bp->bio1);
 		if (linear_make_request(q, &bp->bio2))
_
